classification
Title: "Fatal Python error: Bus error" on the SPARC Solaris 10 buildbot
Type: Stage:
Components: Versions: Python 3.4
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: Nosy List: vstinner
Priority: normal Keywords:

Created on 2014-02-01 02:30 by vstinner, last changed 2014-02-02 22:20 by vstinner. This issue is now closed.

Messages (4)
msg209861 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2014-02-01 02:30
On the buildbot "SPARC Solaris 10 (cc, 64b) [SB] 3.x", Python crash randomly with bus error. It looks like a regression introduced since the build 1422.

Since it's a crash, it probably comes from a change in C module and so I expected this changeset:
http://hg.python.org/cpython/rev/2fbb3c77f1577acc60f57401e07d7feceea66841
"Issue #17919: Fixed integer overflow in the eventmask parameter."

=> see issue #17919

http://buildbot.python.org/all/builders/SPARC%20Solaris%2010%20%28cc%2C%2064b%29%20%5BSB%5D%203.x/builds/1422/

    Change #34778
    Category 	None
    Changed by 	R David Murray <rdmurray@bitdance.com>
    Changed at 	Sat 14 Dec 2013 16:26:20
    Branch 	default
    Revision 	561822250761b47d643656a0be9c71f9d770252b
    Comments

    #19970: fix additional typo in 3.4 asyncio docs.

    Changed files
        Doc/library/asyncio-protocol.rst
    Change #34781
    Category 	None
    Changed by 	Serhiy Storchaka <storchaka@gmail.com>
    Changed at 	Sat 14 Dec 2013 17:19:15
    Branch 	default
    Revision 	2fbb3c77f1577acc60f57401e07d7feceea66841
    Comments

    Issue #17919: Fixed integer overflow in the eventmask parameter.

    Changed files
        Lib/test/test_devpoll.py
        Lib/test/test_poll.py
        Misc/NEWS
        Modules/selectmodule.c
    Change #34784
    Category 	None
    Changed by 	Serhiy Storchaka <storchaka@gmail.com>
    Changed at 	Sat 14 Dec 2013 18:43:21
    Branch 	default
    Revision 	804406d79b45d02b1ea0ae2da45cfd5769141830
    Comments

    Issue #19623: Fixed writing to unseekable files in the aifc module.

    Changed files
        Lib/aifc.py
        Lib/test/audiotests.py
        Lib/test/test_aifc.py
        Lib/test/test_sunau.py
        Lib/test/test_wave.py
        Misc/NEWS
    Change #34786
    Category 	None
    Changed by 	Serhiy Storchaka <storchaka@gmail.com>
    Changed at 	Sat 14 Dec 2013 19:08:18
    Branch 	default
    Revision 	953d8ec1aeb3bff787204343a1c1837a17dbf68c
    Comments

    Null merge

    Changed files
        Lib/test/test_getargs2.py
        Lib/test/test_index.py
        Lib/test/test_int.py
        Misc/NEWS
        Objects/abstract.c
        Objects/longobject.c
msg209862 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2014-02-01 02:34
Example 1:
---

[ 15/388] test_tracemalloc
Fatal Python error: Bus error

Current thread 0x0000000000000001 (most recent call first):
  File "<frozen importlib._bootstrap>", line 321 in _call_with_frames_removed
  File "<frozen importlib._bootstrap>", line 1270 in load_module
  File "<frozen importlib._bootstrap>", line 549 in _requires_builtin_wrapper
  File "<frozen importlib._bootstrap>", line 1160 in _load_backward_compatible
  File "<frozen importlib._bootstrap>", line 1190 in _load_unlocked
  File "<frozen importlib._bootstrap>", line 2202 in _find_and_load_unlocked
  File "<frozen importlib._bootstrap>", line 2213 in _find_and_load
  File "/home/cpython/buildslave/cc-64/3.x.snakebite-sol10-sparc-cc-64/build/Lib/tracemalloc.py", line 8 in <module>
  File "<frozen importlib._bootstrap>", line 321 in _call_with_frames_removed
  File "<frozen importlib._bootstrap>", line 1447 in exec_module
  File "<frozen importlib._bootstrap>", line 1128 in _exec
  File "<frozen importlib._bootstrap>", line 1199 in _load_unlocked
  File "<frozen importlib._bootstrap>", line 2202 in _find_and_load_unlocked
  File "<frozen importlib._bootstrap>", line 2213 in _find_and_load
  File "/home/cpython/buildslave/cc-64/3.x.snakebite-sol10-sparc-cc-64/build/Lib/test/test_tracemalloc.py", line 4 in <module>
  File "<frozen importlib._bootstrap>", line 321 in _call_with_frames_removed
  File "<frozen importlib._bootstrap>", line 1447 in exec_module
  File "<frozen importlib._bootstrap>", line 1128 in _exec
  File "<frozen importlib._bootstrap>", line 1199 in _load_unlocked
  File "<frozen importlib._bootstrap>", line 2202 in _find_and_load_unlocked
  File "<frozen importlib._bootstrap>", line 2213 in _find_and_load
  File "<frozen importlib._bootstrap>", line 2230 in _gcd_import
  File "/home/cpython/buildslave/cc-64/3.x.snakebite-sol10-sparc-cc-64/build/Lib/importlib/__init__.py", line 104 in import_module
  File "/home/cpython/buildslave/cc-64/3.x.snakebite-sol10-sparc-cc-64/build/Lib/test/regrtest.py", line 1271 in runtest_inner
  File "/home/cpython/buildslave/cc-64/3.x.snakebite-sol10-sparc-cc-64/build/Lib/test/regrtest.py", line 967 in runtest
  File "/home/cpython/buildslave/cc-64/3.x.snakebite-sol10-sparc-cc-64/build/Lib/test/regrtest.py", line 763 in main
  File "/home/cpython/buildslave/cc-64/3.x.snakebite-sol10-sparc-cc-64/build/Lib/test/regrtest.py", line 1565 in main_in_temp_cwd
  File "/home/cpython/buildslave/cc-64/3.x.snakebite-sol10-sparc-cc-64/build/Lib/test/__main__.py", line 3 in <module>
  File "/home/cpython/buildslave/cc-64/3.x.snakebite-sol10-sparc-cc-64/build/Lib/runpy.py", line 86 in _run_code
  File "/home/cpython/buildslave/cc-64/3.x.snakebite-sol10-sparc-cc-64/build/Lib/runpy.py", line 171 in _run_module_as_main
...
---

Example 2:
---

[146/387/2] test_pydoc
Fatal Python error: Bus error

Thread 0x0000000000000054 (most recent call first):
  File "/home/cpython/buildslave/cc-64/3.x.snakebite-sol10-sparc-cc-64/build/Lib/threading.py", line 290 in wait
  File "/home/cpython/buildslave/cc-64/3.x.snakebite-sol10-sparc-cc-64/build/Lib/multiprocessing/queues.py", line 230 in _feed
  File "/home/cpython/buildslave/cc-64/3.x.snakebite-sol10-sparc-cc-64/build/Lib/threading.py", line 869 in run
  File "/home/cpython/buildslave/cc-64/3.x.snakebite-sol10-sparc-cc-64/build/Lib/threading.py", line 921 in _bootstrap_inner
  File "/home/cpython/buildslave/cc-64/3.x.snakebite-sol10-sparc-cc-64/build/Lib/threading.py", line 889 in _bootstrap

Current thread 0x0000000000000001 (most recent call first):
  File "<frozen importlib._bootstrap>", line 321 in _call_with_frames_removed
  File "<frozen importlib._bootstrap>", line 1272 in load_module
  File "<frozen importlib._bootstrap>", line 549 in _requires_builtin_wrapper
  File "<frozen importlib._bootstrap>", line 1162 in _load_backward_compatible
  File "<frozen importlib._bootstrap>", line 1200 in _load_unlocked
  File "<frozen importlib._bootstrap>", line 2149 in _find_and_load_unlocked
  File "<frozen importlib._bootstrap>", line 2160 in _find_and_load
  File "/home/cpython/buildslave/cc-64/3.x.snakebite-sol10-sparc-cc-64/build/Lib/pydoc.py", line 1997 in run
  File "/home/cpython/buildslave/cc-64/3.x.snakebite-sol10-sparc-cc-64/build/Lib/pydoc.py", line 2053 in apropos
  File "/home/cpython/buildslave/cc-64/3.x.snakebite-sol10-sparc-cc-64/build/Lib/test/test_pydoc.py", line 577 in test_apropos_with_bad_package
...
---

Example 3:
---

[127/389] test_threading
Fatal Python error: Bus error

Current thread 0x0000000000000001 (most recent call first):
  File "<frozen importlib._bootstrap>", line 321 in _call_with_frames_removed
  File "<frozen importlib._bootstrap>", line 1270 in load_module
  File "<frozen importlib._bootstrap>", line 549 in _requires_builtin_wrapper
  File "<frozen importlib._bootstrap>", line 1160 in _load_backward_compatible
  File "<frozen importlib._bootstrap>", line 1190 in _load_unlocked
  File "<frozen importlib._bootstrap>", line 2202 in _find_and_load_unlocked
  File "<frozen importlib._bootstrap>", line 2213 in _find_and_load
  File "/home/cpython/buildslave/cc-64/3.x.snakebite-sol10-sparc-cc-64/build/Lib/tracemalloc.py", line 8 in <module>
  File "<frozen importlib._bootstrap>", line 321 in _call_with_frames_removed
  File "<frozen importlib._bootstrap>", line 1447 in exec_module
  File "<frozen importlib._bootstrap>", line 1128 in _exec
  File "<frozen importlib._bootstrap>", line 1199 in _load_unlocked
  File "<frozen importlib._bootstrap>", line 2202 in _find_and_load_unlocked
  File "<frozen importlib._bootstrap>", line 2213 in _find_and_load
  File "/home/cpython/buildslave/cc-64/3.x.snakebite-sol10-sparc-cc-64/build/Lib/test/support/__init__.py", line 2167 in run_in_subinterp
  File "/home/cpython/buildslave/cc-64/3.x.snakebite-sol10-sparc-cc-64/build/Lib/test/test_threading.py", line 894 in test_threads_join
...
---

Example 4:
---
[ 41/389] test_capi
Fatal Python error: Bus error

Current thread 0x0000000000000001 (most recent call first):
  File "<frozen importlib._bootstrap>", line 321 in _call_with_frames_removed
  File "<frozen importlib._bootstrap>", line 1270 in load_module
  File "<frozen importlib._bootstrap>", line 549 in _requires_builtin_wrapper
  File "<frozen importlib._bootstrap>", line 1160 in _load_backward_compatible
  File "<frozen importlib._bootstrap>", line 1190 in _load_unlocked
  File "<frozen importlib._bootstrap>", line 2202 in _find_and_load_unlocked
  File "<frozen importlib._bootstrap>", line 2213 in _find_and_load
  File "/home/cpython/buildslave/cc-64/3.x.snakebite-sol10-sparc-cc-64/build/Lib/tracemalloc.py", line 8 in <module>
  File "<frozen importlib._bootstrap>", line 321 in _call_with_frames_removed
  File "<frozen importlib._bootstrap>", line 1447 in exec_module
  File "<frozen importlib._bootstrap>", line 1128 in _exec
  File "<frozen importlib._bootstrap>", line 1199 in _load_unlocked
  File "<frozen importlib._bootstrap>", line 2202 in _find_and_load_unlocked
  File "<frozen importlib._bootstrap>", line 2213 in _find_and_load
  File "/home/cpython/buildslave/cc-64/3.x.snakebite-sol10-sparc-cc-64/build/Lib/test/support/__init__.py", line 2167 in run_in_subinterp
  File "/home/cpython/buildslave/cc-64/3.x.snakebite-sol10-sparc-cc-64/build/Lib/test/test_capi.py", line 240 in test_subinterps
---
msg209866 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2014-02-01 02:56
Since tracemalloc is present many times in the dump and the error is an unaligned memory access, it looks the issue #20354 which I just fixed.

(I also fixed issue #20162 which is another alignment issue, but it may be unrelated to this one.)
msg210037 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2014-02-02 22:20
Cool, the tests are no more crashing on this buildbot. I close the issue.
History
Date User Action Args
2014-02-02 22:20:58vstinnersetstatus: open -> closed
resolution: fixed
messages: + msg210037
2014-02-01 02:56:27vstinnersetmessages: + msg209866
2014-02-01 02:34:59vstinnersetmessages: + msg209862
2014-02-01 02:30:10vstinnercreate